local SpeakUp = SpeakUp
local _G = _G
local PlaySoundFile, UnitIsDead, InCombatLockDown = PlaySoundFile, UnitIsDead, InCombatLockDown
local ipairs, select = ipairs, select
local UnitGUID, UnitName, UnitInParty, UnitInRaid = UnitGUID, UnitName, UnitInParty, UnitInRaid
local petguid

local function playsound(key)
	local file = SpeakUp.LSM:Fetch(SpeakUp.LSM.MediaType.SOUND, key)
	PlaySoundFile(file, "SFX")
end

function SpeakUp:eventHandler(this, event, arg1, ...)
	local amsg
	if event == "ADDON_LOADED" and arg1 == "SpeakUp" then 
		if SpeakUpDB == nil then SpeakUpDB = {} end
		SLASH_SPEAKUP_CMD1 = "/su"
		SLASH_SPEAKUP_CMD2 = "/speakup"
		SlashCmdList["SPEAKUP_CMD"] = function(input) InterfaceOptionsFrame_OpenToCategory("Speak Up") end
	elseif event == "PLAYER_LOGIN" then
		--configure options
		self.defaults = {profile = {},}
		if UnitName("pet") then petguid = UnitGUID("pet") end
		for _, e in ipairs(self.EventList) do
			self.defaults.profile[e.key] = false
			self.defaults.profile[e.key .. "sound"] = "None"
		end
		self.db = self.LS("AceDB-3.0"):New("SpeakUpDB", self.defaults, "profile")
		--add events and custom sounds
		for _, s in ipairs(self.CustomSounds) do self.LSM:Register(self.LSM.MediaType.SOUND, s.desc, "Interface\\Addons\\SpeakUp\\sounds\\" .. s.name .. ".ogg") end
		for _, e in ipairs(self.EventList) do
			if self.db.profile[e.key] then
				if e.event == "COMBAT_LOG_EVENT" then CombatLogAddFilter("UNIT_DIED") end
				self.frame:RegisterEvent(e.event)
			end
		end
		self:createOptions()
	elseif event == "COMBAT_LOG_EVENT" then
		if select(1, ...) == "UNIT_DIED" then
			if petguid == select(7, ...) then if UnitIsDead("pet") and self.db.profile.puu then playsound(self.db.profile.puusound) end
			elseif self.db.profile.cle then
				local pname = select(8, ...)
				if pname ~= UnitName("player") then if UnitInParty(pname) or UnitInRaid(pname) then playsound(self.db.profile.clesound) end end
			end
		end
	elseif event == "UNIT_PET" then if UnitName("pet") then petguid = UnitGUID("pet") end
	elseif event == "CHAT_MSG_SYSTEM" then
		--auction sold
		if self.db.profile.aolu then
			amsg = string.gsub(_G.ERR_AUCTION_SOLD_S, "%.", "%%.")
			amsg = string.gsub(amsg, "%%s", ".*")
			if string.match(arg1, amsg) then playsound(self.db.profile.aolusound) end
		end
		--afk
		if self.db.profile.afk then
			amsg = string.gsub(_G.MARKED_AFK_MESSAGE, "%%s", ".*")
			if string.match(arg1, amsg) then playsound(self.db.profile.afksound) end
		end
	else for _, e in ipairs(self.EventList) do if event == e.event then playsound(self.db.profile[e.key .. "sound"]) end end end
end

